#pragma once
#include <QComboBox>
#include <QColor>
#include <QGLContext>
#include <QGLFormat>
#include <vector>

/*!
 * This class creates the UI element for selecting a color
 * @author Michael Beham
 * @date 3.6.2011
 */
class ColorChooser : public QComboBox
{
	Q_OBJECT
	Q_PROPERTY(QColor color READ color WRITE setColor USER true)

public:
	/*!
	 * Standardconstructor which creates the widget
	 */
	ColorChooser(QWidget* parent = 0);
	/*!
	 * Standarddeconstructor
	 */
	~ColorChooser(void);

public:
	/*!
	 * THis method returns the color
	 * @return [QColor] color.
	 */
     QColor color() const;

	 /*!
	 * THis method sets the color
	 * @param [QColor] c color.
	 */
     void setColor(QColor c);

private:
     void populateList();

public slots:
	

signals:
	/*!
	 * This signal is called, if the selected color is changed.
	 */
	 void currentIndexChanged ( int index );
};
