#pragma once
#include "LoadData.h"
#include "ReadFile.h"

//! LoadTramsferFunction class
/*!
 * Diese Klasse ladet die XML file, indem sie die Werte aus einem XML File rausliest.
 * Die Klasse erbt die Funktionen von LoadData.
*/
class LoadXMLTree : public LoadData, public ReadFile
{
public:
	/**
	 * Konstruktor: Ladet die Datei, welche zum bergebenen Path verknpft wurde.
	 * @param [in] file Pfad zur Datei, welche geladen werden soll.
	 */
	LoadXMLTree();
	/**
	 * Dekonstruktor
	 */
	~LoadXMLTree();
	
	virtual vector<DataFromFile> Read(const char*  path);	
protected:
	/**
	 * Fr jedes Tag in der XML wird diese Funktion aufgerufen.
	 * @param [in] pParent Parent Objekt
	 * @param [in] indent Ebene des Tags
	 */
	void loadingTag(TiXmlNode* pParent, unsigned int indent);
	/**
	* Fr jedes Attribut in der XML Datei wird diese Funktion aufgerufen
	* @param [in] pParent Parent Objekt
	* @param [in] indent Ebene des Tags
	* @return 0
	*/
	int attribsLoading(TiXmlElement* pElement, unsigned int indent);

private:
	//variables for internal use.
	bool failedLoading;
	vector<DataFromFile> data;

	int t_start;
	int t_end;
	int t_root;
	int t_id;
	std::string t_name;
};