#pragma once
/*! \mainpage Hierarchical Edge Bundles
 *  \image html weiters1.png
 * \section autors_sec Autoren 
 * <p>Michael Beham <br />
 * 0726417<br />
 * 066 932</p>
 * <p>Caroline Steiner<br />
 * 0525945<br />
 * 066 932</p>
 *
 *
 * \section intro_sec Aufgabenstellung
 *
 * <p>Die Aufgabenstellung dieses Programmes ist die Darstellung von hierarchischen Daten, welche auch nicht hierarchische Verbindungen besitzen.
 * Dazu stellen wir die Daten wie einen Baum dar, und stellen die Relationskanten zustzlich dar. Fr eine bessere Darstellung, bndeln wir die Daten mithilfe von B-Splines
 * und rendern die nicht hierarchischen Kanten transparent. 
 *
 * \section features_sec Features
 *  @li Rooted Tree layout
 *  @li Ballon Tree layout
 *  @li Slice and Dice Treemap layout
 *  @li Strips Treemap layout
 *  @li Radial Tree layout
 *  @li verschiedene Algorithmen fr die Darstellung von Transparenz.
 *  @li 2 Dateiformate (XML und RTF)
 *  @li Phong Shading und Schatten (Variance shadow mapping)
 *  @li verschiedene Lichttypen (Spotlight, Coniclight, Pointlight)
 *  @li 2D und 3D Darstellung
 *  @li verschiedene Mglichkeiten die Darstellung zu bearbeiten und anzupassen
 *
 * \section download_sec Download
 * Das Programm, knnen Sie <a href="release.zip">hier</a> downloaden. Den Quellcode  <a href="src.zip">hier</a>. Sowie Daten <a href="data.zip">hier</a>
 *
 */

/*! \page gui_control Bedienung
* \section gui GUI
* <p>Nach Starten des Programms sieht man das User Interface mit mehreren Interaktionsmglichkeiten. <br />
* \image html gui.PNG
* Der erste Schritt ist nun das laden eines Datensatzes, dies erfolgt indem man oben links ber das \"File\" \> \"Open\" einen Datensatz auswhlt. <br />
* \image html open.png
* Es knnen zwei Arten von Daten geffnet werden
* @li .rsf
* @li .xml
* </p> 
* <p> Wenn der Datensatz nun geladen ist, knnen mehrer Eingabeparameter verndert werden. Dafr gibt es 2 Tabs <br /> 
* @li Layout
* @li Rendering
*
* \section interaction_sec Interaction Layout
*
* <p> Folgende Einstellungen kann mann ndern 
*
* <table>
* <tr>
* <th> Gui-Element </th>
* <th> Description </th>
* <th> Beispiel </th>
* </tr>
* <tr>
* <td>
* \image html treelayout.PNG
* </td>
* <td> Hier kann zwischen den verschiedenen Darstellungen umgeschalten werden, <br /> fr die Treemap Darstellung gibt es noch zustzliche Parameter, siehe unten</td>
* <td> 
* \image html rooted.PNG
* </td>
* </tr>
* <tr>
* <td>
* \image html drawobjects.PNG
* </td>
* <td> Hiermit kann ausgewhlt werden was gezeichnet werden soll. <br /> In dem Beispiel links werden nur die adjacency edges gezeichnet  </td>
* <td> 
* \image html radial_without.PNG
* </td>
* </tr>
* <tr>
* <td>
* \image html transform.PNG
* </td>
* <td> Mit diesen Schiebereglern kann der Graph rotiert und skaliert werden <br /> Der Schieberegler B-Spline ist fr die Bdelungsstrke zustndig  <br /> weitere Infos zur Zeuerung finden sie weiter unten oder im Programm unter \"Men\" \> \"Steuerung\"  </td>
* <td>
*   <table>
*	<tr>
*		<td> Bdelungsstrke0 </td>
*		<td>
*		\image html beta0.PNG
*		</td>
*	</tr>
*	<tr>
*		<td> Bdelungsstrke 0.5 </td>
*		<td>
*		\image html beta05.PNG
*		</td>
*	</tr>
*	<tr>
*		<td> Bdelungsstrke 1 </td>
*		<td>
*		\image html beta1.PNG
*		</td>
*	</tr>
*	</table>
* </td>
* </tr>
* <tr>
* <td>
* \image html treemap.PNG
* </td>
* <td> Hier kann eine der beiden Darstellungsmglichkeiten <br /> einer Treemap ausgewhlt werden.  </td>
* <td> 
*   <table>
*	<tr>
*		<td> Slice and Dice </td>
*		<td>
*		\image html SliceandDice.PNG
*		</td>
*	</tr>
*	<tr>
*		<td> Strip </td>
*		<td>
*		\image html strips2.PNG
*		</td>
*	</tr>
*	</table>
* </td>
* </tr>
* </table>
*
* \section interaction_rendering Interaction Rendering
*
*
* <table>
* <tr>
* <th> Gui-Element </th>
* <th> Description </th>
* <th> Beispiel </th>
* </tr>
* <tr>
* <td>
* \image html Blending.PNG
* </td>
* <td> Hier knnen verschiedene Blendingmglichkeiten ausgewhlt werden <br /> Standartmig ist \"Standart\" aktiv .<br /> siehe Beispiele oben, nebenstehendes Beispiel hat \"Min/Max \" </td>
* <td> 
* \image html minmax.PNG
* </td>
* </tr>
* <tr>
* <td>
* \image html lighting.PNG
* </td>
* <td> Hier kann man zwischen verschiedenen Arten der Lichtquelle umschalten, <br /> um die Lichtquelle zu bewegen siehe weitere Infos unten  <br /> nebenstehendes Beispiel zeigt eine lighting mit Conic Light </td>
* <td> 
* \image html coniclightinteraction.PNG
* </td>
* </tr>
* <tr>
* <td>
* \image html shadow.PNG
* </td>
* <td> Hier kann ausgewhlt werden welche der folgenden Komponenten <br /> als Schatten auf der weien Flche gezeichnet werden sollen <br /> im Beispiel sieht man die Schattend der Nodes und Relation Edges <br /> die Position der Lichtquelle ist durch den gelben Punkt markiert, und das Licht ist ein Point Light. </td>
* <td> 
* \image html shadowtrans.PNG
* </td>
* </tr>
* <tr>
* <td>
* \image html color.PNG
* </td>
* <td> Hier knnen von den Unterschlichen Objekten die Farbe gendert werden. <br /> Wie z.B. die Farbe der Selection es knnen im Graphen Einzelne Objekte ausgewhlt werden um sie hervorzuheben. <br /> im nebenstehenden Beispiel wurde eine Kante markiert, oben links sieht man nun den Typ/ID sowie weitere Informationen </td>
* <td> 
* \image html selected.PNG
* </td>
* </tr>
* </table>
*
*
* \section camera_sec Interaction Camera
*
*	<p> Wie der Graph bewegt wird, wird in Transform beschrieben, zudem gibt es aber noch weitere Interaktionsmglichkeiten:
*	@li Alt gedrckt halten und Rechte Maustaste : Zoom
*	@li Alt gedrckt halten und Linke Maustaste : Rotation der gesamten Scene
*	@li Alt gedrckt halten und die Tasten W A S D : Positionierung der Lichtquelle
*	@li Alt gedrckt halten und die Tasten R F : Hhe der Lichtquelle
*	</p>
*
*\page pictures Bilder
* Im Folgenden sehen Sie ein paar Ergebnisse dieses Programmes:
*  \image html weiters1.png
*  \image html radialtree.png
*  \image html rootedtree.png
*  \image html light.png
*  \image html strips.png
*  \image html next_rooted.png
*  \image html lowbeta.png
*  \image html stripanddice.png
*  \image html weiters4.png
*  \image html 3dv2.png
*  \image html weiters3.png
*  \image html weiters2.png
*  \image html weightedsum.png
*  \image html coniclight.png
*  \image html pointlight.png
*  \image html spotlight.png
*  \image html caushiontree.png
*  \image html 3d.png
*
*
*\page implementation Implementierung
* <p>Dieses Progamm wurde in C++, Open GL und GLSL implementiert. Die GUI wurde mithilfe von QT implementiert.</p>
* <p>Das Programm wurde in verschiedene Bereiche untergliedert. Nmlich:
* @li GUI, 
* @li Graph, 
* @li Importer,
* @li und Rendering
* </p>
*
* <p>Die GUI wurde mithilfe von QT und den QT Designer erstellt. Dadurch werden in MainWindow nur noch Slots zum laden der QUI Werte bentigt, welche weiters mit einer einfachen statischen Klasse (Renderstates) an den Renderer weitergegeben werden.</p>
* <p>Der Graphteil verwaltet den Baum. Es werden Vertex (Nodes) und Edges (hierarchisch und relation) zur Verfgung gestellt. Man kann Daten hinzufgen, bearbeiten, lschen und einfache Operationen auf dem Graph ausfhren. Der Graph wird mithilfe des Importers erstellt.</p>
* <p>Der Importer erstellt den Graph. Es knnen einerseits XML, anderseits RTF Daten geladen werden.</p>
* <p>Die Darstellung wird im Rendering Teil erstellt. Es wurden verschiedene Renderingpasses erstellt, nmlich fr
* @li Schatten
* @li Standardobjekte
* @li Blending
* </p>
* <p>Beim Schatten wird ein einfacher Variance Shading Mapping (VSM) Algorithmus mithilfe von Shader in GLSL erstellt.</p>
* <p>Die Standardobjekte werden mithilfe von Phongshading schattiert. Desweiteren wird in einem weiteren Farbbuffer die ID jedes Objektes hineingeschrieben um Objekte zu erstellen.
* Wenn der Benutzer ein Objekte auswhlen will, wird einfach an der entsprechendenen Position die ID aus dem Farbbuffer ausgelesen und das ursprngliche Objekte als selektiert markiert.</p>
* <p>Auerdem werden verschiedene Blending Modus zur Verfgung gestellt. Standardblending, Maxblending, Kombination Standard+Maxblending, Weighted Average[3] und Weighted Sum[3].</p>
*
*\section technologies_sec Technologien
* Technologien:
*  @li (Visual Stuio) C++
*  @li OpenGL mit GLSL
*  @li DEVIL, GLEW, QT
*  @li GLM
*  @li TinyXML
*
*\page references Referenzen
* Referenzen:
*  @li <b>[1]</b> Danny Holten, "Hierarchical Edge Bundles: Visualization of Adjacency Relations in Hierarchical Data", IEEE TRANSACTIONS ON VISUALIZATION AND COMPUTER GRAPHICS, VOL. 12, NO. 5, SEPTEMBER/OCTOBER 2006
*  @li <b>[2]</b> Jeromy Carriere, Rick Kazman, "Interacting with Huge Hierarchies: Beyond Cone Trees", Computer Graphics Lab, Department of Computer Science, University of Waterloo, Waterloo, Ontario, Canada N2L 3G1
*  @li <b>[3]</b> Louis Bavoil, Kevin Myers, "Order Independent Transparency with Dual Depth Peeling", NVIDIA Corporation, 2701 San Tomas Expressway, Santa Clara, CA 95050, February 2008
*/


#include "ui_mainWindow.h"
#include <QMainWindow>
#include <QString>

#include "ReadRTFFile.h"
#include "LoadXMLTree.h"
#include "RootedTree.h"
#include "BallonTree.h"
#include "RadialTree.h"
#include "TreeMap.h"
#include "Light.h"

/*!
 * This class initialize and mange the GUI.
 * @author Caroline Steiner und Michael Beham
 * @date 6.6.2011
 */
class MainWindow : public QMainWindow, public Ui::MainWindow
{
	Q_OBJECT

public:
	/*!
	 * standard constructor
	 */
	MainWindow(QWidget* parent = 0);
	/*!
	 * standard deconstructor
	 */
	~MainWindow();

	/*!
	 * Saves the layout data for each layout
	 */
	View* view[5];

private:
	Graph* graph;
	float beta;
signals:
	/*!
	 * If this signal is called, then it calls a method to update the layout data.
	 * We use it after loading data.
	 * @param view [View**] layout data
	 */
	void setView(View** view);

public slots:
	/*!
	 * If the user switch to 2D or 3D mode, the method gets performed.
	 * @param value [bool] true... if the user selected the 3d mode
	 */
	void Mode3D(bool value);

	/*!
	 * This method is called, if the user selected another layout tree.
	 * @param value [bool] true.. if the user selected the rooted layout.
	 */
	void SetViewToRooted(bool value);
	/*!
	 * This method is called, if the user selected another layout tree.
	 * @param value [bool] true.. if the user selected the ballon layout.
	 */
	void SetViewToBallon(bool value);
	/*!
	 * This method is called, if the user selected another layout tree.
	 * @param value [bool] true.. if the user selected the treemap layout.
	 */
	void SetViewToTreeMap(bool value);
	/*!
	 * This method is called, if the user selected another layout tree.
	 * @param value [bool] true.. if the user selected the radial layout.
	 */
	void DrawRadialTree(bool value);

	/*!
	 * This method is called, if the user enables or disables the blending mode.
	 * @param value [bool] true.. if the user enables blending.
	 */
	void EnableBlending(bool value);
	/*!
	 * This method is called, if the user updates the blending mode.
	 * @param value [bool] true.. if the user enables stanard blending.
	 */
	void SetStandardBlending(bool value);
	/*!
	 * This method is called, if the user updates the blending mode.
	 * @param value [bool] true.. if the user enables minmax blending.
	 */
	void SetMinMaxBlending(bool value);
	/*!
	 * This method is called, if the user updates the blending mode.
	 * @param value [bool] true.. if the user enables minmax + standard blending.
	 */
	void SetStandardMinMaxBlending(bool value);
	/*!
	 * This method is called, if the user updates the blending mode.
	 * @param value [bool] true.. if the user enables average weihting blending.
	 */
	void SetAverageWeightingBlending(bool value);
	/*!
	 * This method is called, if the user updates the blending mode.
	 * @param value [bool] true.. if the user enables summed average weihting blending.
	 */
	void SetSummedAverageBlending(bool value);
	
	/*!
	 * This method is called, if the user enables or disables the light.
	 * @param value [bool] true.. if the user enables the light.
	 */
	void EnableLight(bool value);
	/*!
	 * This method is called, if the user updates the lighttype.
	 * @param value [bool] true.. if the user enables the spotlight.
	 */
	void EnableSpotLight(bool value);
	/*!
	 * This method is called, if the user updates the lighttype.
	 * @param value [bool] true.. if the user enables the conic light.
	 */
	void EnableConicLight(bool value);
	/*!
	 * This method is called, if the user updates the lighttype.
	 * @param value [bool] true.. if the user enables the point light.
	 */
	void EnablePointLight(bool value);
	
	/*!
	 * This method is called, if the user enables or disables the shading.
	 * @param value [bool] true.. if the user enables the shadow.
	 */
	void EnableShadow(bool value);
	/*!
	 * This method is called, if the user enables or disables displaying vertices in shadow.
	 * @param value [bool] true.. if the user enables displays displaying vertices in shadow.
	 */
	void SetVertexInShadow(bool value);
	/*!
	 * This method is called, if the user enables or disables displaying hierarchy edges in shadow.
	 * @param value [bool] true.. if the user enables displays displaying hierarchy edges in shadow.
	 */
	void SetHierarchyEdgeInShadow(bool value);
	/*!
	 * This method is called, if the user enables or disables displaying relation edges in shadow.
	 * @param value [bool] true.. if the user enables displays displaying relation edges in shadow.
	 */
	void SetRelationEdgeInShadow(bool value);
	/*!
	 * This method is called, if the user enables or disables displaying grids in shadow.
	 * @param value [bool] true.. if the user enables displays displaying grids in shadow.
	 */
	void SetGridInShadow(bool value);
	
	/*!
	 * This method is called, if the user enables or disables drawing nodes.
	 * @param value [bool] true.. if the user enables drawing nodes.
	 */
	void DrawNodes(bool value);
	/*!
	 * This method is called, if the user enables or disables drawing hierarchy edges.
	 * @param value [bool] true.. if the user enables drawing hierarchy edges.
	 */
	void DrawHierarchyEdges(bool value);
	/*!
	 * This method is called, if the user enables or disables drawing relation edges.
	 * @param value [bool] true.. if the user enables drawing relation edges.
	 */
	void DrawRelationEdges(bool value);
	/*!
	 * This method is called, if the user enables or disables drawing the grid.
	 * @param value [bool] true.. if the user enables drawing the grid.
	 */
	void DrawGrid(bool value);

	/*!
	 * This method is called, if the user changes the x-rotation of the tree.
	 * @param value [int] new x-rotation value.
	 */
	void RotateX(int value);
	/*!
	 * This method is called, if the user changes the y-rotation of the tree.
	 * @param value [int] new y-rotation value.
	 */
	void RotateY(int value);
	/*!
	 * This method is called, if the user changes the z-rotation of the tree.
	 * @param value [int] new z-rotation value.
	 */
	void RotateZ(int value);
	/*!
	 * This method is called, if the user changes the scale of the tree.
	 * @param value [int] new scale value.
	 */
	void Scale(int value);

	/*!
	 * This method is called, if the user updates the treemap layout type.
	 * @param value [bool] true, if the user selected the slice and dice layout.
	 */
	void DrawSliceAndDice(bool value);
	/*!
	 * This method is called, if the user updates the treemap layout type.
	 * @param value [bool] true, if the user selected the strips layout.
	 */
	void DrawStrips(bool value);
	/*!
	 * This method is called, if the user enables or disables the cushion texture.
	 * @param value [bool] true, if the user enables the cushion texture.
	 */
	void DrawCushionTexture(bool value);

	/*!
	 * This method is called, if the user changes the light attentuate.
	 * @param value [int] light attenuate
	 */
	void SetLightAttenuate(int value);
	/*!
	 * This method is called, if the user changes the light radius.
	 * @param value [int] light radius
	 */
	void SetLightRadius(int value);

	void MirrorRelationEdges(bool value);

	/*!
	 * This method is called, if the user changes the node color.
	 * @param value [QString] new sphere color.
	 */
	void SphereColorChanged(const QString value);
	/*!
	 * This method is called, if the user changes the hierarchy edge color.
	 * @param value [QString] new hierarchy edge color.
	 */
	void HierarchyColorChanged(const QString value);
	/*!
	 * This method is called, if the user changes the start relation edge color.
	 * @param value [QString] new relation edge color.
	 */
	void RelationStartColorChanged(const QString value);
	/*!
	 * This method is called, if the user changes the end relation edge color.
	 * @param value [QString] new relation edge color.
	 */
	void RelationEndColorChanged(const QString value);
	/*!
	 * This method is called, if the user changes the end selection color.
	 * @param value [QString] new selection color.
	 */
	void SelectionColorChanged(const QString value);
	/*!
	 * This method is called, if the user changes the alpha value.
	 * @param value [int] new alpha value.
	 */
	void RelationAlpha(int value);

	/*!
	 * This method is called, if the user changes the beta.
	 * @param value [int] new beta value.
	 */
	void SetBeta(int value);
	/*!
	 * This method is called, if the user changed the beta value.
	 */
	void BetaChanged();
private slots:
	/*!
	 * This method is called, if the user open a file.
	 */
	void openFileDialog();
	/*!
	 * This method is called, if the user saves a Screenshot
	 */
	void saveFileDialog();
	/*!
	 * This method is called, if the user wants to know more about the Programm
	 */
	void aboutDialog();
	/*!
	 * This method is called, to give more information about the Unser interaction 
	 */
	void controlDialog();
};