#pragma once
#include <boost/lexical_cast.hpp>
#include <iostream>
#include <fstream>
#include <string>
#include <vector>

#include "Graph.h"

using namespace std;

/*!
 * This class can considers as a own fileformat in which the XML and RTF formats gets converted.
 * Then we only read the DataFromFile format for creating the graph
 * @date 3.6.2011
 * @author Michael Beham
 */
class DataFromFile
{
public:
	/*!
	 * Standardconstructor
	 */
	DataFromFile(void);
	/*!
	 * Standarddeconstructor
	 */
	~DataFromFile(void);

	/*!
	 * Subject defines the type of the value
	 */
	string subject;
	/*!
	 * Value
	 */
	vector<string> value;
};

/*!
 * This class is a parent class for loading the data
 * @author Michael Beham
 * @date 3.6.2011
 */
class ReadFile
{
public:
	/*!
	 * Standardconstructor
	 */
	ReadFile(void);
	/*!
	 * Standarddeconstructor
	 */
	~ReadFile(void);

	/*!
	 * This virtual method gets implemented from the childclasses
	 */
	virtual vector<DataFromFile> Read(const char* path)=0;
	/*!
	 * This method converts the DataFromFile vector to a graph
	 * @param [vector<DataFromFile>] data from file
	 * @return [Graph] The resulting graph
	 */
	Graph* ConvertToDataStructure(vector<DataFromFile>);
};
