#pragma once
#include "RenderTree.h"
#include "BallonTree.h"

/*!
 * This class renders the ballontree layout.
 * @author Michael beham
 * @date 3.6.2011
 */
class RenderBallonTree : public RenderTree
{
public:
	/*!
	 * Standardconstructor, which initialize the data
	 */
	RenderBallonTree();
	/*!
	 * Standarddeconstructor
	 */
	~RenderBallonTree(void);

	/*!
	 * This method draws the Grid.
	 */
	void DrawGrid();
	/*!
	 * This method draws the vertices
	 */
	void DrawVertices();
	/*!
	 * This method draws all vertices, without the passed vertex.
	 * @param [VertexPtr] v Vertex which shouldn't draw.
	 */
	void DrawWithoutVertex(VertexPtr v);
	/*!
	 * This method draws a passed vertex.
	 * @param [VertexPtr] v Vertex which should draw.
	 */
	void DrawVertex(VertexPtr v);
};
