#pragma once
#include "glm/glm.hpp"
using glm::vec3;

/*!
 * This class draws some primitives object. 
 * It uses the displaylists
 * @author Michael Beham
 * @date 3.6.2011
 */
class RenderPrimitives
{
public:
	/*!
	* Standardconstructor
	*/
	RenderPrimitives(void);
	/*!
	 * Standarddeconstructor
	 */
	~RenderPrimitives(void);

	/*!
	 * This method creates all display lists for drawing the primitives.
	 */
	static void Initialize(void);
	/*!
	 * This method delets all display lists
	 */
	static void Deinitialize();
	/*!
	 * This method draws a spheres
	 */
	static void DrawSphere();
	/*!
	 * This method draws a circle.
	 */
	static void DrawCircle();
	/*!
	 * This method draws a cube.
	 */
	static void DrawCube();
	/*!
	 * This method draws a rectangle
	 */
	static void DrawRectangle();
	/*!
	 * This method draws a quad.
	 */
	static void DrawQuad();
	/*!
	 * This method draws a billboard
	 */
	static void DrawBillboard();

private:
	//DisplayList
	static unsigned int dl_cube;
	static unsigned int dl_sphere;
	static unsigned int dl_circle;
	static unsigned int dl_rectangle;
	static unsigned int dl_quad;
	static unsigned int dl_billboard;
};
