#pragma once
#include "RenderTree.h"

/*!
 * This method renders a radial tree.
 * @author Michael Beham
 * @date 3.6.2011
 */
class RenderRadialTree : public RenderTree
{
public:
	/*!
	 * Standardconstructor
	 */
	RenderRadialTree(void);
	/*!
	 * Standarddeconstructor
	 */
	~RenderRadialTree(void);

	/*!
	 * This method draws a grid.
	 */
	void DrawGrid();
	/*!
	 * This method draws the vertices
	 */
	void DrawVertices();
	/*!
	 * This method draws all vertices, without the passed vertex.
	 * @param [VertexPtr] v Vertex which shouldn't draw.
	 */
	void DrawWithoutVertex(VertexPtr v);
	/*!
	 * This method draws a passed vertex.
	 * @param [VertexPtr] v Vertex which should draw.
	 */
	void DrawVertex(VertexPtr v);
};
