#pragma once
#include "Image.h"

/*!
 * This class provides a set of textures for drawing.
 * @author Michael Beham
 * @date 3.6.2011
 */
class RenderTextures
{
public:
	/*!
	 * Standardconstructor
	 */
	RenderTextures(void);
	/*!
	 * Standarddeconstructor
	 */
	~RenderTextures(void);

	/*!
	 * This method creates the textures
	 */
	static void Initialize();	
	/*!
	 * This method deletes all textures
	 */
	static void Deinitialize();
	/*!
	 * This method set the cushion texture to Texture0
	 */
	static void RenderCushionTexture();
	/*!
	 * This method set the light texture to Texture 0
	 */
	static void RenderLightTexture();
	/*!
	 * This method unbind the texture
	 */
	static void End();

private:
	static unsigned int CreateTexture(Image* img);

	static unsigned int m_cushiontex;
	static unsigned int m_lighttex;
};
