#pragma once
#include "common.h"
#include "RenderPrimitives.h"
#include "RenderTextures.h"
#include "View.h"

/*!
 * This method is the parent class for rendering the treelayouts.
 * @author Michael Beham
 * @date 3.6.2011
 */
class RenderTree
{
public:
	/*!
	 * Standardconstructor
	 */
	RenderTree(void);
	/*!
	 * virtual deconstructor
	 */
	virtual ~RenderTree(void);

	
	/*!
	 * This method draws the Grid.
	 */	
	void DrawGrid(int);
	/*!
	 * This method draws the vertices
	 */
	void DrawVertices(int);
	/*!
	 * This method draws all vertices, without the passed vertex.
	 * @param [VertexPtr] v Vertex which shouldn't draw.
	 */
	void DrawWithoutVertex(int, VertexPtr v);
	/*!
	 * This method draws a passed vertex.
	 * @param [VertexPtr] v Vertex which should draw.
	 */
	void DrawVertex(int, VertexPtr v);

	View* m_view;
	unsigned int mode;
};
