#pragma once
#include "RenderTree.h"

/*!
 * This class renders the treemap layout.
 * @author Michael beham
 * @date 3.6.2011
 */
class RenderTreeMap : public RenderTree
{
public:
	/*!
	 * Standardconstructor, which initialize the data
	 */
	RenderTreeMap(void);
	/*!
	 * Standarddeconstructor
	 */
	~RenderTreeMap(void);

	bool m_cushiontexture;

	/*!
	 * This method draws the Grid.
	 */	
	void DrawGrid();
	/*!
	 * This method draws the vertices
	 */
	void DrawVertices();
	/*!
	 * This method draws all vertices, without the passed vertex.
	 * @param [VertexPtr] v Vertex which shouldn't draw.
	 */
	void DrawWithoutVertex(VertexPtr v);
	/*!
	 * This method draws a passed vertex.
	 * @param [VertexPtr] v Vertex which should draw.
	 */
	void DrawVertex(VertexPtr v);
};
