#pragma once
#include <stdlib.h>
#include <io.h>
#include <iostream>
#include <sstream>
#include <string>
#include <vector>

//!  ShaderObj class. 
/*!
 * Diese Klasse dient als Container der Shader. Einerseits wird die ShaderID gespeichert, anderseits die IDs fr die Objekte der Shader.
 * Alle Shader werden gleich behandelt, sprich besitzen alle die gleichen Uniform Attribute und Vertex Shader. Dadurch lsst sich die Komplexitt der Shaderverwaltung reduzieren.
 * (Stichwort: Alles ber die Leiste scherren)
 * @author Michael Beham
 * @date 4.12.2010
*/
class ParameterObj
{
public: 
	enum ParameterObjType
	{
		PT_INT,
		PT_FLOAT,
		PT_INT2,
		PT_FLOAT2,
		PT_INT3,
		PT_FLOAT3,
		PT_INT4,
		PT_FLOAT4,
		PT_MAT2,
		PT_MAT3,
		PT_MAT4
	};

	unsigned int id;
	ParameterObjType type;
	float* value;

	const char* var;
};

class ShaderObj
{
public:
	unsigned int shaderID;
	std::vector<ParameterObj*> parameters; 

	const char* vertexshader;
	const char* fragmentshader;
};