#pragma once
#include "common.h"
#include "Graph.h"
#include <iostream>
#include <iomanip>
#include <string>
#include <map>
#include <glew.h>

//!View class
/*!
 * Diese abstrakte Klasse dient fr die Definition der Layoutdaten fr die verschiedenen Trees.
 * @author Michael Beham
 * @date 5.12.2010
*/
class View
{
public:
	/*!
	* Dieses Enum spezifiziert den Typ des Objektes.
	*/
	enum ViewMethods
	{
		VM_ROOTEDTREE,
		VM_BALLONTREE,
		VM_TREEMAP_SLICE_AND_DICE,
		VM_TREEMAP_STRIP,
		VM_RADIALTREE,
		VM_QUANTITY		//Bitte, neue Typen vor VM_QUANTITY einfgen. Dieses Element soll das letzte sein, damit ich dann die Gre des Enum wei.
	};

	/*!
	 * Konstruktor. Initialisiert die Werte auf Defaultwerte
	 */
	View();
	/*!
	 * Dekonstruktor
	 */
	~View(void);

	/*!
	 * Diese Methode wird vom Child implementiert, wo das Layout berechnet wird.
	 */
	virtual void Calculate() = 0;

	/*!
	 * Diese Methode bergibt den Childs den Graphdateb
	 * @param [Graph*] graph Graph Objekt.
	 */
	static void SetGraph(Graph* grah);
	/*!
	 * Diese Methode setzt fr ein Vertex ein GUIVertex 
	 * @param [unsigned int] id ID des korrespondierenden Vertex.
	 * @param [GUIVertex] GUIVertex Objekt.
	 */
	void SetGUIVertexForView(unsigned int id, GUIVertex vertex);
	/*!
	 * Diese Methode liefert das GUIVertex zu einer bergebenen id.
	 * @param [unsigned int] id Id des Vertex
	 * @return [GUIVertex] GUIVertex Objekt
	 */
	GUIVertex GetGUIVertexForView(unsigned int id);

	std::map<unsigned int, GUIVertex> m_guivertex;
	static Graph* m_pkGraph;

public:
	//VBOS...
	unsigned int vbohierarchylines_vert;
	unsigned int vbohierarchylines_color;
	unsigned int vboindex_picking_ind;
	//unsigned int dl_relation;

};
