#include "ColorChooser.h"

ColorChooser::ColorChooser(QWidget* parent) : QComboBox(parent)
{
	populateList();
}

ColorChooser::~ColorChooser(void)
{
}

QColor ColorChooser::color() const
{
	return qVariantValue<QColor>(itemData(currentIndex(), Qt::DecorationRole));
}

void ColorChooser::setColor(QColor color)
{
	setCurrentIndex(findData(color, int(Qt::DecorationRole)));
}

void ColorChooser::populateList()
{
    QStringList colorNames = QColor::colorNames();

	for (int i = 0; i < colorNames.size(); ++i) {
        QColor color(colorNames[i]);

        insertItem(i, colorNames[i]);
		setItemData(i, color, Qt::DecorationRole);
	}
}