#include "GUIVertex.h"

GUIVertex::GUIVertex() : m_position(0,0,0)
{
	
}

GUIVertex::GUIVertex(vec3 position) : m_position(position)
{
	
}

GUIVertex::GUIVertex(vec3 position, vec3 color) : m_position(position), m_color(color.x, color.y, color.z, 1.0)
{

}

GUIVertex::GUIVertex(vec3 position, vec3 color, float opacity) : m_position(position), m_color(color.x, color.y, color.z, opacity)
{

}

GUIVertex::~GUIVertex(void)
{

}

void GUIVertex::SetPosition(vec3 pos)
{
	m_position = pos;
}

vec3 GUIVertex::GetPosition()
{
	return m_position;
}

void GUIVertex::SetColor(vec3 color)
{
	m_color.x = color.x;
	m_color.y = color.y;
	m_color.z = color.z;
}

vec3 GUIVertex::GetColor()
{
	return vec3(m_color.x, m_color.y, m_color.z);
}

void GUIVertex::SetOpacity(float opacity)
{
	m_color.w = opacity;
}

float GUIVertex::GetOpacity()
{
	return m_color.w;
}