#include "Image.h"

std::vector<Image*> Image::images;

bool Image::LoadImg(ILenum Type, char *FileName)
{	
	std::cout << "LOAD IMG: " << FileName << std::endl;
	ilEnable(IL_ORIGIN_SET);
	ilGenImages(1, &handle);
	ilBindImage(handle);
	ILboolean loaded = ilLoadImage(FileName);	
	if (loaded == IL_FALSE) return false;

	ilConvertImage(IL_RGBA, IL_UNSIGNED_BYTE); 

	width = ilGetInteger(IL_IMAGE_WIDTH); // getting image width
	height = ilGetInteger(IL_IMAGE_HEIGHT); // and height

	int memory_needed = width * height * 4 * sizeof(unsigned char);
	data = (ILubyte *)malloc(memory_needed);

	ilCopyPixels(0, 0, 0, width, height, 1, IL_RGBA, IL_UNSIGNED_BYTE, data);

	imageload = true;
	return true;
}

ILfloat* Image::LoadImgGetFloat(ILenum Type, char *FileName, int& mwidth, int& mheight)
{	
	ILuint handle;

	std::cout << "LOAD IMG: " << FileName << std::endl;
	ilEnable(IL_ORIGIN_SET);
	ilGenImages(1, & handle);
	ilBindImage(handle);
	ILboolean loaded = ilLoadImage(FileName);
	
	if (loaded == IL_FALSE) return 0;

	if(mwidth > 0 && mheight > 0)
	{
		std::cout << "HIER BIN ICH" << std::endl;
		ilSetInteger(IL_IMAGE_WIDTH, mwidth); // getting image width
		ilSetInteger(IL_IMAGE_HEIGHT, mheight); // and height
	}
	else
	{
		mwidth = ilGetInteger(IL_IMAGE_WIDTH); // getting image width
		mheight = ilGetInteger(IL_IMAGE_HEIGHT); // and height
	}

	ilConvertImage(IL_RGB, IL_FLOAT); 

	int memory_needed = mwidth * mheight * 3 * sizeof(ILfloat);
	ILfloat* tmpdata = (ILfloat *)malloc(memory_needed);

	ilCopyPixels(0, 0, 0, mwidth, mheight, 1, IL_RGB, IL_FLOAT, tmpdata);
	ilBindImage(0);
	ilDeleteImages(1, &handle); 
	return tmpdata;
}


ILubyte* Image::GetData()
{
	return data;
}

bool Image::IsImageLoad()
{
	return imageload;
}

int Image::GetHeight()
{
	return (int) height;
}

int Image::GetWidth()
{
	return (int) width;
}