#include "Light.h"

Light::Light(void) : m_on(true), m_actType(LT_CONIC), m_position(0,0,0), m_spotdirection(0,-1,0), m_radius(1.0)
{
}

Light::~Light(void)
{
}

void Light::On()
{
	m_on = true;
}

void Light::Off()
{
	m_on = false;
}

bool Light::IsOn()
{
	return m_on;
}

void Light::ShadowOn()
{
	m_shadowon = true;
}

void Light::ShadowOff()
{
	m_shadowon = false;
}

bool Light::IsShadowOn()
{
	return m_shadowon;
}

void Light::SetType(int type)
{
	m_actType = type;
}

void Light::SetPosition(vec3 position)
{
	m_position = position;
}

void Light::SetSpotDirection(vec3 spotdirection)
{	
	m_spotdirection = spotdirection;
}

void Light::SetRadius(float radius)
{
	m_radius = radius;
}

float Light::GetType()
{
	return m_actType;
}

vec3 Light::GetPosition()
{
	return m_position;
}

vec3 Light::GetSpotDirection()
{
	return m_spotdirection;
}

float Light::GetRadius()
{
	return m_radius;
}

void Light::SetShadowElements(int elements)
{
	switch(elements)
	{
	case 0:	m_shadowvertices = false;
			m_shadowhierarchyedge = false;
			m_shadowrelationedge = false;
			m_shadowgrid = false;
		break;
	case 1:	m_shadowvertices = true;
			m_shadowhierarchyedge = false;
			m_shadowrelationedge = false;
			m_shadowgrid = false;
		break;
	case 2:	m_shadowvertices = false;
			m_shadowhierarchyedge = true;
			m_shadowrelationedge = false;
			m_shadowgrid = false;
		break;
	case 3:	m_shadowvertices = true;
			m_shadowhierarchyedge = true;
			m_shadowrelationedge = false;
			m_shadowgrid = false;
		break;
	case 4:	m_shadowvertices = false;
			m_shadowhierarchyedge = false;
			m_shadowrelationedge = true;
			m_shadowgrid = false;
		break;
	case 5:	m_shadowvertices = true;
			m_shadowhierarchyedge = false;
			m_shadowrelationedge = true;
			m_shadowgrid = false;
		break;
	case 6:	m_shadowvertices = false;
			m_shadowhierarchyedge = true;
			m_shadowrelationedge = true;
			m_shadowgrid = false;
		break;
	case 7:	m_shadowvertices = true;
			m_shadowhierarchyedge = true;
			m_shadowrelationedge = true;
			m_shadowgrid = false;
		break;
	case 8:	m_shadowvertices = false;
			m_shadowhierarchyedge = false;
			m_shadowrelationedge = false;
			m_shadowgrid = true;
		break;
	case 9:	m_shadowvertices = true;
			m_shadowhierarchyedge = false;
			m_shadowrelationedge = false;
			m_shadowgrid = true;
		break;
	case 10:m_shadowvertices = false;
			m_shadowhierarchyedge = true;
			m_shadowrelationedge = false;
			m_shadowgrid = true;
		break;
	case 11:m_shadowvertices = true;
			m_shadowhierarchyedge = true;
			m_shadowrelationedge = false;
			m_shadowgrid = true;
		break;
	case 12:m_shadowvertices = false;
			m_shadowhierarchyedge = false;
			m_shadowrelationedge = true;
			m_shadowgrid = true;
		break;
	case 13:m_shadowvertices = true;
			m_shadowhierarchyedge = false;
			m_shadowrelationedge = true;
			m_shadowgrid = true;
		break;
	case 14:m_shadowvertices = false;
			m_shadowhierarchyedge = true;
			m_shadowrelationedge = true;
			m_shadowgrid = true;
		break;
	case 15:m_shadowvertices = true;
			m_shadowhierarchyedge = true;
			m_shadowrelationedge = true;
			m_shadowgrid = true;
	}
}

bool Light::AreGridsInShadow()
{
	return m_shadowgrid;
}

bool Light::AreVerticesInShadow()
{
	return m_shadowvertices;
}

bool Light::AreHierarchyEdgeInShadow()
{
	return m_shadowhierarchyedge;
}

bool Light::AreRelationEdgeInShadow()
{
	return m_shadowrelationedge;
}

void Light::SetAttentuate(float attentuate)
{
	m_attentuate = attentuate;
}

float Light::GetAttentuate()
{
	return m_attentuate;
}