#include "LoadXMLTree.h"

LoadXMLTree::LoadXMLTree() : LoadData()
{
}

LoadXMLTree::~LoadXMLTree()
{
	data.clear();
}

vector<DataFromFile> LoadXMLTree::Read(const char*  path)
{
	data.clear();
	std::cout << "READXMLFILE" << std::endl;
	ReadXMLFile(path);
	loadingTag(&doc,0);
	return data;
}

void LoadXMLTree::loadingTag(TiXmlNode* pParent, unsigned int indent)
{
	if ( !pParent ) return;

	TiXmlNode* pChild;
	TiXmlText* pText;
	int t = pParent->Type();
	int num;
	
	const std::string nRoot = "Root";
	const std::string nNode = "Node";
	const std::string nHierarchyEdge = "HierarchyEdge";
	const std::string nRelationEdge = "RelationEdge";

	std::cout << "pParent->Value():" << pParent->Value() << std::endl;
	switch ( t )
	{
		case TiXmlNode::TEXT:
			pText = pParent->ToText();
			std::cout << "pText: "<< pText << std::endl;
		break;

		case TiXmlNode::ELEMENT:
		{
			num=attribsLoading(pParent->ToElement(), indent+1);

			if(pParent->Value() == nRoot)
			{
				DataFromFile datei;
				datei.subject = "Root";
				datei.value.push_back(GetIntegerToString(t_root));
				data.push_back(datei);
			}
			if(pParent->Value() == nNode)
			{
				DataFromFile datei;
				datei.subject = "H";
				datei.value.push_back(GetIntegerToString(t_id));
				datei.value.push_back(t_name);
				data.push_back(datei);
			}
			if(pParent->Value() == nHierarchyEdge)
			{
				DataFromFile datei;
				datei.subject = "PCR";
				datei.value.push_back(GetIntegerToString(t_start));
				datei.value.push_back(GetIntegerToString(t_end));
				data.push_back(datei);
			}
			if(pParent->Value() == nRelationEdge)
			{
				DataFromFile datei;
				datei.subject = "R";
				datei.value.push_back(GetIntegerToString(t_start));
				datei.value.push_back(GetIntegerToString(t_end));
				data.push_back(datei);
			}
			
			break;
		}
		default: break;
	}

	for ( pChild = pParent->FirstChild(); pChild != 0; pChild = pChild->NextSibling()) 
	{
		loadingTag( pChild, indent+1 );
	}
}

int LoadXMLTree::attribsLoading(TiXmlElement* pElement, unsigned int indent)
{
	if ( !pElement ) return 0;

	TiXmlAttribute* pAttrib=pElement->FirstAttribute();

	int ival;
	const std::string nroot = "root_id";
	const std::string nstart = "start";
	const std::string nend = "end";
	const std::string nid = "id";
	const std::string nname = "name";

	int i=0;
	const char* pIndent=getIndent(indent);
	
	while (pAttrib)
	{
		const char* attr = pAttrib->Name();

		if(attr == nroot && pAttrib->QueryIntValue(&ival)==TIXML_SUCCESS)	t_root = ival; 
		if(attr == nstart && pAttrib->QueryIntValue(&ival)==TIXML_SUCCESS)	t_start = ival; 
		if(attr == nend && pAttrib->QueryIntValue(&ival)==TIXML_SUCCESS)	t_end = ival; 
		if(attr == nid && pAttrib->QueryIntValue(&ival)==TIXML_SUCCESS)		t_id = ival; 
		if(attr == nname)	t_name = pAttrib->Value();

		i++;
		pAttrib=pAttrib->Next();
	}
	return 0;	
}