#include "RadialTree.h"
#include <glm/gtc/matrix_transform.hpp> //translate, rotate, scale, perspective

/*
Rooted Tree:


				  *
			 /		\
			*		 *
	      / |    \	  \
	     *  *     *	   *
		   /|\   /|\
		  * * * * * *

  Number of Levels: 4
  Number of Vertices without childs: 8
*/

RadialTree::RadialTree()
{
}

RadialTree::~RadialTree(void)
{
}

void RadialTree::Calculate()
{
	std::map<unsigned int, double> angles;

	std::vector<VertexPtr> verticesWithoutChilds  = m_pkGraph->GetAllVerticesWithoutChild();
	//Nun wei ich wieviele Vertices ohne Child gibt, und wieviele Ebenen
	int numberOfVerticesWithoutChilds = verticesWithoutChilds.size();
	int numberOfLevels = m_pkGraph->GetNumberOfHierarchies();

	std::vector<unsigned int> parents;
	std::vector<unsigned int> parents_cpy;
	parents.resize(0);
	parents_cpy.resize(0);
	angles.clear();
	//Setzt alle unteren mal korrekt.
	
	//std::sort(verticesWithoutChilds.begin(), verticesWithoutChilds.end());
	std::cout << "Radialtree 0" << std::endl;
	double tmpRadius = 0.0;
	double nangle = 360.0/(double)(verticesWithoutChilds.size());
	for(double i = 0; i < verticesWithoutChilds.size(); i++)
	{
		VertexPtr actVertex = verticesWithoutChilds[(unsigned int)i];
		angles.insert(pair<unsigned int,double>(actVertex->GetID(), tmpRadius));
		tmpRadius += nangle;

		bool helper = false;
		for(int h = 0; h < parents.size(); h++)
		{
			if(parents[h] == actVertex->GetParent()->GetID()) {helper = true; break;}
		}
		if(!helper) parents.push_back(actVertex->GetParent()->GetID());
	}

	std::cout << "Radialtree 1" << std::endl;
	vec3 startpos (0.0,1.0,0.0);

	int actlevel = m_pkGraph->GetNumberOfHierarchies()-2;

	while(parents.size() > 0 && actlevel > 0)
	{
		for(int i = parents.size()-1; i >= 0 && actlevel > 0; i--)
		{
			if(actlevel == m_pkGraph->GetVertexWithID(parents[i])->GetHierarchyLevel())
			{
				std::cout << "begin " << std::endl;
		
				VertexPtr actVertex = m_pkGraph->GetVertexWithID(parents[i]);
				tmpRadius = 0.f;
				for(unsigned int j = 0; j < actVertex->GetNumberChildVertices(); j++)
				{
					float helper = 0.f;
					if(j > 0 && angles[actVertex->GetChildVertexAt(j)->GetID()] < angles[actVertex->GetChildVertexAt(j-1)->GetID()])
					{
					//	helper = 360.f;
					}

					float tmphelp = helper+angles[actVertex->GetChildVertexAt(j)->GetID()];
					tmpRadius += tmphelp;
					std::cout << "tmphelp: " << tmphelp << std::endl;
				}
				tmpRadius /= (float)(actVertex->GetNumberChildVertices());
				std::cout << "ANGLE: " << tmpRadius << std::endl;
				if(actVertex->GetParent() == 0)		tmpRadius = 0.0;
				angles.insert(pair<unsigned int,double>(actVertex->GetID(), tmpRadius));

				//if(actVertex->GetParent() != 0) parents.push_back(actVertex->GetParent()->GetID());
				std::cout << "before" << std::endl;
				if(actVertex->GetParent() != 0)
				{
					bool helper = false;
					for(int h = 0; h < parents.size(); h++)
					{
						if(parents[h] == actVertex->GetParent()->GetID()) {helper = true; }
					}	
					if(!helper) parents.push_back(actVertex->GetParent()->GetID());
				}
				std::cout << "after" << std::endl;
	
				//parents.erase(parents.begin()+i); 
				std::cout << "ende " << std::endl;
			}
		}
		actlevel--;
	}

	std::cout << "Radialtree 2" << std::endl;

	VertexPtr actVert = m_pkGraph->GetRoot();
	std::vector<VertexPtr> childVertex;
	childVertex.push_back(actVert);

	float pi = PI;
	int actHierarchy = 0;
	for(unsigned int i = 0; i < childVertex.size(); i++)
	{
		VertexPtr newVert = childVertex[i];

		vec4 pos;
		vec3 startpos (0.0,-1.0,0.0);
		mat4 rotmat(1.0);
		mat4 m = glm::rotate(rotmat, (float)angles[newVert->GetID()], vec3(0.0f, 1.0f, 0.0f));
		pos = vec4((float)(newVert->GetHierarchyLevel())/(float)(m_pkGraph->GetNumberOfHierarchies()),0.0f,0.0f,1.0f)*m;

		SetGUIVertexForView(newVert->GetID(), GUIVertex( vec3(pos.x, pos.y, pos.z ),vec3(1,0,0),0.8 ));
		for(unsigned int j = 0; j < newVert->GetNumberChildVertices(); j++)
		{
			childVertex.push_back(newVert->GetChildVertexAt(j));
		}
	}
}
