#include "RenderBallonTree.h"

RenderBallonTree::RenderBallonTree() 
{
}

RenderBallonTree::~RenderBallonTree(void)
{
}

void RenderBallonTree::DrawGrid()
{
	BallonTree* ballon = dynamic_cast<BallonTree*>(m_view);

	//Draw Vertices (Nodes)
	for(unsigned int i = 0; i < ballon->verticesChilds.size(); i++)
	{		
		glPushMatrix();	
		glTranslatef(ballon->GetGUIVertexForView(ballon->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().x , 1.0f-ballon->GetGUIVertexForView(ballon->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().y, ballon->GetGUIVertexForView(ballon->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().z);
		glScalef(ballon->verticesChilds[i]->GetRadius()*1.0,ballon->verticesChilds[i]->GetRadius()*1.0,ballon->verticesChilds[i]->GetRadius()*1.0);
		RenderPrimitives::DrawCircle();
		glPopMatrix();
		
	}
}

void RenderBallonTree::DrawVertices()
{
	BallonTree* ballon = dynamic_cast<BallonTree*>(m_view);

	//Draw Vertices (Nodes)
	for(unsigned int i = 0; i < ballon->verticesChilds.size(); i++)
	{
		glPushMatrix();	
		//glLoadIdentity();
		glTranslatef(ballon->GetGUIVertexForView(ballon->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().x , 1.0f-ballon->GetGUIVertexForView(ballon->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().y, ballon->GetGUIVertexForView(ballon->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().z);
	
		//glMultiTexCoord3f(GL_TEXTURE7, (float)(i)/(float)(ballon->verticesChilds.size()),0,0);
		glColor4f((float)(i)/(float)(ballon->verticesChilds.size()),0,0,1);
		RenderPrimitives::DrawSphere();
		glPopMatrix();		
	}
}

void RenderBallonTree::DrawVertex(VertexPtr v)
{
	BallonTree* ballon = dynamic_cast<BallonTree*>(m_view);

	//Draw Vertices (Nodes)
	int i = v->GetID();

		glPushMatrix();	
		//glLoadIdentity();
		glTranslatef(ballon->GetGUIVertexForView(ballon->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().x , 1.0f-ballon->GetGUIVertexForView(ballon->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().y, ballon->GetGUIVertexForView(ballon->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().z);
	
		//glMultiTexCoord3f(GL_TEXTURE7, (float)(i)/(float)(ballon->verticesChilds.size()),0,0);
		glColor4f((float)(i)/(float)(ballon->verticesChilds.size()),0,0,1);
		RenderPrimitives::DrawSphere();
		glPopMatrix();		
	
}

void RenderBallonTree::DrawWithoutVertex(VertexPtr v)
{
	BallonTree* ballon = dynamic_cast<BallonTree*>(m_view);

	//Draw Vertices (Nodes)
	for(unsigned int i = 0; i < ballon->verticesChilds.size(); i++)
	{
		if(i != v->GetID())
		{
			glPushMatrix();	
			//glLoadIdentity();
			glTranslatef(ballon->GetGUIVertexForView(ballon->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().x , 1.0f-ballon->GetGUIVertexForView(ballon->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().y, ballon->GetGUIVertexForView(ballon->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().z);
	
			//glMultiTexCoord3f(GL_TEXTURE7, (float)(i)/(float)(ballon->verticesChilds.size()),0,0);
			glColor4f((float)(i)/(float)(ballon->verticesChilds.size()),0,0,1);
			RenderPrimitives::DrawSphere();
			glPopMatrix();		
		}
	}
}