#include "RenderPrimitives.h"
#include "glew.h"
#include "common.h"


unsigned int RenderPrimitives::dl_sphere = 0;
unsigned int RenderPrimitives::dl_circle = 0;
unsigned int RenderPrimitives::dl_cube = 0;
unsigned int RenderPrimitives::dl_rectangle = 0;
unsigned int RenderPrimitives::dl_quad = 0;
unsigned int RenderPrimitives::dl_billboard = 0;

RenderPrimitives::RenderPrimitives(void)
{
}

RenderPrimitives::~RenderPrimitives(void)
{

}

void RenderPrimitives::Deinitialize()
{
	glDeleteLists(dl_sphere,1);
	glDeleteLists(dl_circle,1);
	glDeleteLists(dl_cube,1);
	glDeleteLists(dl_rectangle,1);
	glDeleteLists(dl_quad,1);
}

void RenderPrimitives::Initialize(void)
{
	GLUquadricObj*	qobj = gluNewQuadric();
	gluQuadricDrawStyle(qobj, GLU_FILL);
	gluQuadricNormals(qobj, GLU_SMOOTH);
	gluQuadricTexture(qobj, true);
	
	dl_sphere = glGenLists(1);

	glNewList(dl_sphere, GL_COMPILE);
    gluSphere(	qobj, 0.01, 20,	20);
	glEndList();

	//delete qobj;

	dl_circle = glGenLists(1);
	glNewList(dl_circle, GL_COMPILE);
	glBegin(GL_LINE_STRIP);
	for(float i = 0.0f; i <= 360.0f; i+=5.0f)
	{
		glNormal3f(0,1,0);
		glMultiTexCoord2f(GL_TEXTURE0, sinf( PI/180.0f*i),cosf( PI/180.0f*i));	
		glVertex3f(sinf( PI/180.0f*i),0.0f, cosf( PI/180.0f*i));
	}
	glEnd();
	glEndList();

	dl_cube = glGenLists(1);
	glNewList(dl_cube, GL_COMPILE);
	glBegin(GL_QUADS);
		glNormal3f( 0, 1, 0);	glMultiTexCoord2f(GL_TEXTURE0, 1, 0);	glVertex3f( 1, 1,-1);
		glNormal3f( 0, 1, 0);	glMultiTexCoord2f(GL_TEXTURE0, 0, 0);	glVertex3f(-1, 1,-1);
		glNormal3f( 0, 1, 0);	glMultiTexCoord2f(GL_TEXTURE0, 0, 1);	glVertex3f(-1, 1, 1);
		glNormal3f( 0, 1, 0);	glMultiTexCoord2f(GL_TEXTURE0, 1, 1);	glVertex3f( 1, 1, 1);
		
		glNormal3f( 0,-1, 0);	glMultiTexCoord2f(GL_TEXTURE0, 1, 1);	glVertex3f( 1,-1, 1);
		glNormal3f( 0,-1, 0);	glMultiTexCoord2f(GL_TEXTURE0, 0, 1);	glVertex3f(-1,-1, 1);
		glNormal3f( 0,-1, 0);	glMultiTexCoord2f(GL_TEXTURE0, 0, 0);	glVertex3f(-1,-1,-1);
		glNormal3f( 0,-1, 0);	glMultiTexCoord2f(GL_TEXTURE0, 1, 0);	glVertex3f( 1,-1,-1);

		glNormal3f( 0, 0, 1);	glMultiTexCoord2f(GL_TEXTURE0, 1, 1);	glVertex3f( 1, 1, 1);
		glNormal3f( 0, 0, 1);	glMultiTexCoord2f(GL_TEXTURE0, 0, 1);	glVertex3f(-1, 1, 1);
		glNormal3f( 0, 0, 1);	glMultiTexCoord2f(GL_TEXTURE0, 0, 0);	glVertex3f(-1,-1, 1);
		glNormal3f( 0, 0, 1);	glMultiTexCoord2f(GL_TEXTURE0, 1, 0);	glVertex3f( 1,-1, 1);

		glNormal3f( 0, 0,-1);	glMultiTexCoord2f(GL_TEXTURE0, 1, 0);	glVertex3f( 1,-1,-1);
		glNormal3f( 0, 0,-1);	glMultiTexCoord2f(GL_TEXTURE0, 0, 0);	glVertex3f(-1,-1,-1);
		glNormal3f( 0, 0,-1);	glMultiTexCoord2f(GL_TEXTURE0, 0, 1);	glVertex3f(-1, 1,-1);
		glNormal3f( 0, 0,-1);	glMultiTexCoord2f(GL_TEXTURE0, 1, 1);	glVertex3f( 1, 1,-1);

		glNormal3f(-1, 0, 0);	glMultiTexCoord2f(GL_TEXTURE0, 1, 1);	glVertex3f(-1, 1, 1);
		glNormal3f(-1, 0, 0);	glMultiTexCoord2f(GL_TEXTURE0, 1, 0);	glVertex3f(-1, 1,-1);
		glNormal3f(-1, 0, 0);	glMultiTexCoord2f(GL_TEXTURE0, 0, 0);	glVertex3f(-1,-1,-1);
		glNormal3f(-1, 0, 0);	glMultiTexCoord2f(GL_TEXTURE0, 0, 1);	glVertex3f(-1,-1, 1);

		glNormal3f( 1, 0, 0);	glMultiTexCoord2f(GL_TEXTURE0, 1, 0);	glVertex3f( 1, 1,-1);
		glNormal3f( 1, 0, 0);	glMultiTexCoord2f(GL_TEXTURE0, 1, 1);	glVertex3f( 1, 1, 1);
		glNormal3f( 1, 0, 0);	glMultiTexCoord2f(GL_TEXTURE0, 0, 1);	glVertex3f( 1,-1, 1);
		glNormal3f( 1, 0, 0);	glMultiTexCoord2f(GL_TEXTURE0, 0, 0);	glVertex3f( 1,-1,-1);
	glEnd();
	glEndList();

	dl_rectangle = glGenLists(1);
	glNewList(dl_rectangle, GL_COMPILE);
	glBegin(GL_LINE_STRIP);
		glNormal3f( 0, 1, 0);	glMultiTexCoord2f(GL_TEXTURE0, 0, 0);	glVertex3f( 0, 0, 0);
		glNormal3f( 0, 1, 0);	glMultiTexCoord2f(GL_TEXTURE0, 0, 1);	glVertex3f( 0, 0, 1);
		glNormal3f( 0, 1, 0);	glMultiTexCoord2f(GL_TEXTURE0, 1, 1);	glVertex3f( 1, 0, 1);
		glNormal3f( 0, 1, 0);	glMultiTexCoord2f(GL_TEXTURE0, 1, 0);	glVertex3f( 1, 0, 0);
		glNormal3f( 0, 1, 0);	glMultiTexCoord2f(GL_TEXTURE0, 0, 0);	glVertex3f( 0, 0, 0);
	glEnd();
	glEndList();

	dl_quad = glGenLists(1);
	glNewList(dl_quad, GL_COMPILE);
	glBegin(GL_QUADS);
		glNormal3f( 0, 1, 0);	glMultiTexCoord2f(GL_TEXTURE0, 0, 0);		glVertex3f( 0, 0, 0);
		glNormal3f( 0, 1, 0);	glMultiTexCoord2f(GL_TEXTURE0, 0, 1);		glVertex3f( 0, 0, 1);
		glNormal3f( 0, 1, 0);	glMultiTexCoord2f(GL_TEXTURE0, 1, 1);		glVertex3f( 1, 0, 1);
		glNormal3f( 0, 1, 0);	glMultiTexCoord2f(GL_TEXTURE0, 1, 0);		glVertex3f( 1, 0, 0);
	glEnd();
	glEndList();

	dl_billboard = glGenLists(1);
	glNewList(dl_billboard, GL_COMPILE);
	/*glEnable(GL_POINT_SPRITE_ARB);
	glTexEnvi(GL_POINT_SPRITE_ARB, GL_COORD_REPLACE_ARB, GL_TRUE);
	//glEnable(GL_VERTEX_PROGRAM_POINT_SIZE);
	glPointSize(40.0);
	glBegin(GL_POINTS);
		glVertex3f(0,0,0);
	glEnd();
	glDisable(GL_POINT_SPRITE);
	/*/
	glPushMatrix();
	glScalef(0.1,0.1,0.1);
	glTranslatef(-0.5,0,-0.5);
	glBegin(GL_QUADS);
		glNormal3f( 0, 1, 0);	glMultiTexCoord2f(GL_TEXTURE0, 0, 0);		glVertex3f( 0, 0, 0);
		glNormal3f( 0, 1, 0);	glMultiTexCoord2f(GL_TEXTURE0, 0, 1);		glVertex3f( 0, 0, 1);
		glNormal3f( 0, 1, 0);	glMultiTexCoord2f(GL_TEXTURE0, 1, 1);		glVertex3f( 1, 0, 1);
		glNormal3f( 0, 1, 0);	glMultiTexCoord2f(GL_TEXTURE0, 1, 0);		glVertex3f( 1, 0, 0);
	glEnd();
	glPopMatrix();//*/
	glEndList();
}

void RenderPrimitives::DrawSphere()
{
	glCallList(dl_sphere);
}

void RenderPrimitives::DrawCircle()
{
	glCallList(dl_circle);
}

void RenderPrimitives::DrawCube()
{
	glCallList(dl_cube);
}

void RenderPrimitives::DrawRectangle()
{
	glCallList(dl_rectangle);
}

void RenderPrimitives::DrawQuad()
{
	glCallList(dl_quad);
}

void RenderPrimitives::DrawBillboard()
{
	glCallList(dl_billboard);
}