#include "RenderTextures.h"
#include "glew.h"
#include <QtOpenGL>
#include "common.h"

unsigned int RenderTextures::m_cushiontex = 0;
unsigned int RenderTextures::m_lighttex = 0;


RenderTextures::RenderTextures(void)
{

}

RenderTextures::~RenderTextures(void)
{
}

void RenderTextures::Initialize()
{
	Image* img_cushion = new Image();
	img_cushion->LoadImg(IL_PNG, "imgs/cushion_tex.png");
	m_cushiontex = CreateTexture(img_cushion);
	delete(img_cushion);

	Image* img_lighttex = new Image();
	img_lighttex->LoadImg(IL_PNG, "imgs/lighttex.png");
	m_lighttex = CreateTexture(img_lighttex);
	delete(img_lighttex);
}

void RenderTextures::Deinitialize()
{
	glDeleteTextures(1, &m_cushiontex);
}

unsigned int RenderTextures::CreateTexture(Image* img)
{
	unsigned int texname = 0;
	glGenTextures(1, &texname);		
	glBindTexture(GL_TEXTURE_2D, texname);

	if(GLEW_EXT_texture_filter_anisotropic) 
	{
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAX_ANISOTROPY_EXT, 16.0f);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T, GL_CLAMP);
		gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGBA, img->GetWidth(), img->GetHeight(), GL_RGBA, GL_UNSIGNED_BYTE, img->GetData());
	}
	else
	{
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR_MIPMAP_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
		gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGBA, img->GetWidth(), img->GetHeight(), GL_RGBA, GL_UNSIGNED_BYTE, img->GetData());
	}
	return texname;
}

void RenderTextures::End()
{
	glActiveTexture(GL_TEXTURE0);
	glDisable(GL_TEXTURE_2D);
}

void RenderTextures::RenderCushionTexture()
{
	glActiveTexture(GL_TEXTURE0);
	glBindTexture(GL_TEXTURE_2D, RenderTextures::m_cushiontex);
	glEnable(GL_TEXTURE_2D);
}

void RenderTextures::RenderLightTexture()
{
	glActiveTexture(GL_TEXTURE0);
	glBindTexture(GL_TEXTURE_2D, RenderTextures::m_lighttex);
	glEnable(GL_TEXTURE_2D);
}