#include "RenderTree.h"
#include "TreeMap.h"
#include "RootedTree.h"


RenderTree::RenderTree(void)
{
}

RenderTree::~RenderTree(void)
{
}

void RenderTree::DrawGrid(int actView)
{

}

void RenderTree::DrawWithoutVertex(int actView, VertexPtr vertex)
{
	TreeMap* treemap;
	RootedTree* rootedtree;
	if(actView == View::VM_TREEMAP_SLICE_AND_DICE || actView == View::VM_TREEMAP_STRIP) treemap = dynamic_cast<TreeMap*>(m_view);
	if(actView == View::VM_ROOTEDTREE) rootedtree = dynamic_cast<RootedTree*>(m_view);

	float numVert = (float)(View::m_pkGraph->GetNumberOfVertices());

	//Draw Vertices (Nodes)
	for(int i = 0; i < View::m_pkGraph->GetNumberOfVertices(); i++)
	{
		if(i != vertex->GetID())
		{
			glPushMatrix();	
			glTranslatef(m_view->GetGUIVertexForView(m_view->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().x , 1.0f-m_view->GetGUIVertexForView(m_view->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().y, m_view->GetGUIVertexForView(m_view->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().z);
			glColor4f((float)(i)/numVert,0,0,1);
			//glMultiTexCoord3f(GL_TEXTURE7, (float)(i)/numVert,0,0);
			RenderPrimitives::DrawSphere();
			glPopMatrix();
		}
	}
}

void RenderTree::DrawVertex(int actView, VertexPtr vertex)
{
	TreeMap* treemap;
	RootedTree* rootedtree;
	if(actView == View::VM_TREEMAP_SLICE_AND_DICE || actView == View::VM_TREEMAP_STRIP) treemap = dynamic_cast<TreeMap*>(m_view);
	if(actView == View::VM_ROOTEDTREE) rootedtree = dynamic_cast<RootedTree*>(m_view);

	float numVert = (float)(View::m_pkGraph->GetNumberOfVertices());

	//Draw Vertices (Nodes)
	int i = vertex->GetID();

	glPushMatrix();	
	glTranslatef(m_view->GetGUIVertexForView(m_view->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().x , 1.0f-m_view->GetGUIVertexForView(m_view->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().y, m_view->GetGUIVertexForView(m_view->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().z);
	glColor4f((float)(i)/numVert,0,0,1);
	glMultiTexCoord3f(GL_TEXTURE7, (float)(i)/numVert,0,0);
	RenderPrimitives::DrawSphere();
	glPopMatrix();
}

void RenderTree::DrawVertices(int actView)
{
	TreeMap* treemap;
	RootedTree* rootedtree;
	if(actView == View::VM_TREEMAP_SLICE_AND_DICE || actView == View::VM_TREEMAP_STRIP) treemap = dynamic_cast<TreeMap*>(m_view);
	if(actView == View::VM_ROOTEDTREE) rootedtree = dynamic_cast<RootedTree*>(m_view);

	float numVert = (float)(View::m_pkGraph->GetNumberOfVertices());

	//Draw Vertices (Nodes)
	for(int i = 0; i < View::m_pkGraph->GetNumberOfVertices(); i++)
	{
		glPushMatrix();	
		glTranslatef(m_view->GetGUIVertexForView(m_view->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().x , 1.0f-m_view->GetGUIVertexForView(m_view->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().y, m_view->GetGUIVertexForView(m_view->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().z);
		glColor4f((float)(i)/numVert,0,0,1);
		//glMultiTexCoord3f(GL_TEXTURE7, (float)(i)/numVert,0,0);
		RenderPrimitives::DrawSphere();
		glPopMatrix();
	}
}