#include "RenderTreeMap.h"
#include "TreeMap.h"
#include "RenderTextures.h"

RenderTreeMap::RenderTreeMap(void)
{
}

RenderTreeMap::~RenderTreeMap(void)
{

}

void RenderTreeMap::DrawGrid()
{
	TreeMap* treemap = dynamic_cast<TreeMap*>(m_view);
	float numVert = (float)(View::m_pkGraph->GetNumberOfVertices());

	for(int i = 0; i < View::m_pkGraph->GetNumberOfVertices(); i++)
	{	
		glPushMatrix();
		glTranslated(0,-1e-3f, 0);
		glTranslated(m_view->GetGUIVertexForView(m_view->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().x , 1.0f-m_view->GetGUIVertexForView(m_view->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().y, m_view->GetGUIVertexForView(m_view->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().z);
		glTranslated(-treemap->m_mapVertex[m_view->m_pkGraph->GetVertexWithID(i)->GetID()]->GetWidth() * 0.5, 0.0, -treemap->m_mapVertex[m_view->m_pkGraph->GetVertexWithID(i)->GetID()]->GetHeight() * 0.5);
		glScaled(treemap->m_mapVertex[m_view->m_pkGraph->GetVertexWithID(i)->GetID()]->GetWidth(), 0.0, treemap->m_mapVertex[m_view->m_pkGraph->GetVertexWithID(i)->GetID()]->GetHeight());
		glColor4d(1.0,1.0,1.0,1.0);

		if(m_cushiontexture && m_view->m_pkGraph->GetVertexWithID(i)->GetNumberChildVertices() == 0)
		{
			RenderTextures::RenderCushionTexture();
			RenderPrimitives::DrawQuad();
			RenderTextures::End();
		}
		else	RenderPrimitives::DrawRectangle();
		glPopMatrix();
	}
}

void RenderTreeMap::DrawVertices()
{
	TreeMap* treemap = dynamic_cast<TreeMap*>(m_view);
	float numVert = (float)(View::m_pkGraph->GetNumberOfVertices());

	for(int i = 0; i < View::m_pkGraph->GetNumberOfVertices(); i++)
	{
		glPushMatrix();	
		glTranslatef(m_view->GetGUIVertexForView(m_view->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().x , 1.0f-m_view->GetGUIVertexForView(m_view->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().y, m_view->GetGUIVertexForView(m_view->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().z);
		glColor4f((float)(i)/numVert,0,0,1);
		RenderPrimitives::DrawSphere();
		glPopMatrix();
	}
}

void RenderTreeMap::DrawVertex(VertexPtr v)
{
	TreeMap* treemap = dynamic_cast<TreeMap*>(m_view);
	float numVert = (float)(View::m_pkGraph->GetNumberOfVertices());

	int i = v->GetID();

		glPushMatrix();	
		glTranslatef(m_view->GetGUIVertexForView(m_view->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().x , 1.0f-m_view->GetGUIVertexForView(m_view->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().y, m_view->GetGUIVertexForView(m_view->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().z);
		glColor4f((float)(i)/numVert,0,0,1);
		RenderPrimitives::DrawSphere();
		glPopMatrix();
}

void RenderTreeMap::DrawWithoutVertex(VertexPtr v)
{
	TreeMap* treemap = dynamic_cast<TreeMap*>(m_view);
	float numVert = (float)(View::m_pkGraph->GetNumberOfVertices());

	for(int i = 0; i < View::m_pkGraph->GetNumberOfVertices(); i++)
	{
		if(i != v->GetID())
		{
			glPushMatrix();	
			glTranslatef(m_view->GetGUIVertexForView(m_view->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().x , 1.0f-m_view->GetGUIVertexForView(m_view->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().y, m_view->GetGUIVertexForView(m_view->m_pkGraph->GetVertexWithID(i)->GetID()).GetPosition().z);
			glColor4f((float)(i)/numVert,0,0,1);
			RenderPrimitives::DrawSphere();
			glPopMatrix();
		}
	}
}