#include "SelectedObject.h"

SelectedObject::SelectedObject(void) : obj_type(SelectedObject::SO_NONE), m_oldhelper(-1), m_helper(-1)
{
}

SelectedObject::~SelectedObject(void)
{

}

SelectedObject::SelectedObject(VertexPtr obj) : obj_type(SelectedObject::SO_Vertex), vertex_obj(obj)
{
}

SelectedObject::SelectedObject(HierarchyPtr obj) : obj_type(SelectedObject::SO_HEDGE), hierarchy_obj(obj)
{
}

SelectedObject::SelectedObject(RelationPtr obj) : obj_type(SelectedObject::SO_REDGE), relation_obj(obj)
{
}

void SelectedObject::SetSelectedObj(VertexPtr obj)
{
	obj_type = SelectedObject::SO_Vertex;
	vertex_obj = obj;
}

void SelectedObject::SetSelectedObj(HierarchyPtr obj)
{
	obj_type = SelectedObject::SO_HEDGE;
	old_hierarchy_obj = hierarchy_obj;
	hierarchy_obj = obj;
}

void SelectedObject::SetSelectedObj(RelationPtr obj, int helper)
{
	obj_type = SelectedObject::SO_REDGE;
	old_relation_obj = relation_obj;
	relation_obj = obj;
	m_oldhelper = m_helper;
	m_helper = helper;
}

int SelectedObject::GetActualSelectedObjType()
{
	return obj_type;
}

VertexPtr SelectedObject::GetVertex()
{
	return vertex_obj;
}

HierarchyPtr SelectedObject::GetHierarchyEdge()
{
	return hierarchy_obj;
}

RelationPtr SelectedObject::GetRelationEdge()
{
	return relation_obj;
}

HierarchyPtr SelectedObject::GetOldHierarchyEdge()
{
	return old_hierarchy_obj;
}

RelationPtr SelectedObject::GetOldRelationEdge()
{
	return old_relation_obj;
}