#include "TreeMap.h"

Strip::Strip()
{

}

Strip::~Strip()
{

}

unsigned int Strip::GetNumberOfItems()		{	return m_items.size();	}
VertexPtr Strip::GetItemAt(int at)	{	return m_items[at];		}

void Strip::AddItem(VertexPtr item)				{	m_items.push_back(item);}
void Strip::SetItemAtt(VertexPtr item, int at)	{	m_items[at] = item;		}

void Strip::RemoveLastItem()			{ m_items.erase(m_items.end()-1);	}
void Strip::RemoveItemAt(int at)		{ m_items.erase(m_items.begin()+at);	}
void Strip::RemoveItemAt(VertexPtr item)		
{ 
	for(unsigned int i = 0; i  < m_items.size(); i++) 
	{ 
		if(m_items[i]->GetID() == item->GetID()) 
		{
			RemoveItemAt(i); 
			return; 
		}
	}
}

MapVertex::MapVertex(VertexPtr owner, double width, double height) : m_owner(owner), m_width(width), m_height(height)
{
	StripPtr tmp(new Strip());
	AddStrip(tmp);
}

double MapVertex::CalculateAvarangeAspectRatio()
{
	//Add the next rectangle to the current strip, recomputing the height of the strip based on the area of all the rectangles within the strip, and then recomputing the width of each rectangle.
	/*double maxstripaspect = 0; 
	for(unsigned int i = 0; i < GetNumberOfStrips(); i++) 
	{
		float avg1 = (GetWidthOfItemsAtStrip(i) / GetHeightOfItems());
		float avg2 = (GetHeightOfItems()/GetWidthOfItemsAtStrip(i));
		//maxstripaspect += max(avg1,avg2);
		maxstripaspect += avg1;
	}
	return maxstripaspect/(double)(GetNumberOfStrips()); /*/

	float avg1 = (GetWidthOfItemsAtLastStrip() / GetHeightOfItems());
	float avg2 = (GetHeightOfItems()/GetWidthOfItemsAtLastStrip());
	//return avg1;
	return max(avg1,avg2);//*/
}
double MapVertex::CalculateLastAspectRatio()			{ return GetWidthOfItemsAtLastStrip() / GetHeightOfItems(); }
double MapVertex::CalculateAspectRatioOfStrip(int at)	{	return GetWidthOfItemsAtStrip(at) / GetHeightOfItems(); }

double MapVertex::GetWidth()			{	return m_width;		}
double MapVertex::GetHeight()			{	return m_height;	}

void MapVertex::SetWidth(double width)		{	m_width = width;		}
void MapVertex::SetHeight(double height)	{	m_height = height;		}

double MapVertex::GetWidthOfItemsAtStrip(unsigned int at)	{	return m_width/(double)(m_strips[at]->GetNumberOfItems());					}
double MapVertex::GetWidthOfItemsAtLastStrip()				{	return m_width/(double)(m_strips[m_strips.size()-1]->GetNumberOfItems());	}
double MapVertex::GetHeightOfItems()						{	return m_height/(double)(m_strips.size());								}

VertexPtr MapVertex::GetOwner()				{	return m_owner;			}
void MapVertex::SetOwner(VertexPtr owner)	{	m_owner = owner;		}

unsigned int MapVertex::GetNumberOfStrips()								{	return m_strips.size();		}
void MapVertex::AddStrip(MapVertex::StripPtr strip)						{	m_strips.push_back(strip);	}
void MapVertex::SetStripAt(MapVertex::StripPtr strip, unsigned int at)	{	m_strips[at] = strip;		}
MapVertex::StripPtr MapVertex::GetStripAt(unsigned int at)				{	return m_strips[at];		}
MapVertex::StripPtr MapVertex::GetLastStrip()							{	return m_strips[m_strips.size()-1];	}
void MapVertex::RemoveStripAt(int at)									{	m_strips.erase(m_strips.begin()+at);}


TreeMap::TreeMap(int type) : m_type(type)
{
}

TreeMap::~TreeMap(void)
{
}


/*
Algorithmus: Strips

input : Rectangle rectangleParent,Node[] children
1 Erstelle leeren Streifen in rectangleParent;
2 for Node n in children;
3 do
4	Fge n in aktuellen Streifen ein ;
5	if Durchschnitt Aspect Ratio schlechter als vorher then
6		Entferne n aus Streifen;
7		Schliee aktuellen Streifen ab;
8		Erzeuge einen neuen Streifen und fge n dort nun ein;
*/
void TreeMap::CalculateStrip(MapVertexPtr actStrip)
{
	double old_aspectRatio =  max(actStrip->GetWidth()/actStrip->GetHeight(),actStrip->GetHeight()/actStrip->GetWidth());
	if(actStrip->GetOwner()->GetNumberChildVertices() > 0)
	{	
		VertexPtr item = actStrip->GetOwner()->GetChildVertexAt(0);

		//Fge n in aktuellen Streifen ein
		actStrip->GetLastStrip()->AddItem(item);
			
		old_aspectRatio = actStrip->CalculateAvarangeAspectRatio();
	}


	for(unsigned int i = 1; i < actStrip->GetOwner()->GetNumberChildVertices(); i++)	//for Node n in children
	{
		VertexPtr item = actStrip->GetOwner()->GetChildVertexAt(i);

		//Fge n in aktuellen Streifen ein
		actStrip->GetLastStrip()->AddItem(item);
			
		double aspectRatio = actStrip->CalculateAvarangeAspectRatio();
		std::cout << "Aspect Ratio: " << aspectRatio << std::endl;

		//if(aspectRatio < 1.0)	//if Durchschnitt Aspect Ratio schlechter als vorher then
		if(aspectRatio >= old_aspectRatio)
		{
			//Schliee aktuellen Streifen ab
			actStrip->GetLastStrip()->RemoveLastItem();
			
			//Erzeuge einen neuen Streifen 
			StripPtr tmpStr(new Strip());
			actStrip->AddStrip(tmpStr);

			//und fge n dort nun ein...
			actStrip->GetLastStrip()->AddItem(item);

			aspectRatio = actStrip->CalculateAvarangeAspectRatio();
		}
		old_aspectRatio = aspectRatio;
	}

	double tmpHeight = actStrip->GetHeight()/(double)(actStrip->GetNumberOfStrips());

	for(unsigned int i = 0; i < actStrip->GetNumberOfStrips(); i++)	//for Node n in children
	{
		double tmpWidth = actStrip->GetWidth()/(double)(actStrip->GetStripAt(i)->GetNumberOfItems());

		for(unsigned int j = 0; j < actStrip->GetStripAt(i)->GetNumberOfItems(); j++)
		{
			VertexPtr node = actStrip->GetStripAt(i)->GetItemAt(j);

			MapVertexPtr tmpStart(new MapVertex(node,tmpWidth,tmpHeight));
			m_mapVertex.insert(std::pair<unsigned int, MapVertexPtr>(node->GetID(), tmpStart));
		
			CalculateStrip(m_mapVertex[node->GetID()]);
		}
	}
}

/*
________________________________________
|  |  |  |  |  |  |  |  |  |  |  |  |  |
|  |  |  |  |  |  |  |  |  |  |  |  |  |
|  |  |  |  |  |  |  |  |  |  |  |  |  |
|  |  |  |  |  |  |  |  |  |  |  |  |  |
|  |  |  |  |  |  |  |  |  |  |  |  |  |
|  |  |  |  |  |  |  |  |  |  |  |  |  |
________________________________________
*/

void TreeMap::CalculateStripSliceAndDice(MapVertexPtr actStrip, bool horizontal)
{
	for(unsigned int i = 0; i < actStrip->GetOwner()->GetNumberChildVertices(); i++)	//for Node n in children
	{
		VertexPtr item = actStrip->GetOwner()->GetChildVertexAt(i);

		//Fge n in aktuellen Streifen ein
		if(horizontal)		actStrip->GetLastStrip()->AddItem(item);
		else				
		{
			if(i > 0)
			{
				StripPtr tmpStr(new Strip());
				actStrip->AddStrip(tmpStr);
			}
			actStrip->GetLastStrip()->AddItem(item);
		}
	}

	double tmpHeight = actStrip->GetHeight()/(double)(actStrip->GetNumberOfStrips());

	for(unsigned int i = 0; i < actStrip->GetNumberOfStrips(); i++)	//for Node n in children
	{
		double tmpWidth = actStrip->GetWidth()/(double)(actStrip->GetStripAt(i)->GetNumberOfItems());

		for(unsigned int j = 0; j < actStrip->GetStripAt(i)->GetNumberOfItems(); j++)
		{
			VertexPtr node = actStrip->GetStripAt(i)->GetItemAt(j);
			MapVertexPtr tmpStart(new MapVertex(node,tmpWidth,tmpHeight));
			m_mapVertex.insert(std::pair<unsigned int, MapVertexPtr>(node->GetID(), tmpStart));
			CalculateStripSliceAndDice(m_mapVertex[node->GetID()], !horizontal);
		}
	}
}

void TreeMap::Calculate()
{
	VertexPtr parentNode = m_pkGraph->GetRoot();

	MapVertexPtr tmpStart(new MapVertex(parentNode,1,1));
	m_mapVertex.insert(std::pair<unsigned int, MapVertexPtr>(parentNode->GetID(), tmpStart));

	switch(m_type)
	{
	case 0: CalculateStripSliceAndDice(m_mapVertex[parentNode->GetID()],true);	
			break;
	case 1: CalculateStrip(m_mapVertex[parentNode->GetID()]);	
			break;
	}
	
	//Calclate Position (sind nachher alle am Eckpunkte)
	std::vector<MapVertexPtr> ptr;
	ptr.push_back(m_mapVertex[parentNode->GetID()]);
	SetGUIVertexForView(ptr[0]->GetOwner()->GetID(), GUIVertex(vec3(0.0,0.5,0.0), vec3(0,1,1), 1));
	while(ptr.size() > 0)
	{
		vec3 pos = GetGUIVertexForView(ptr[0]->GetOwner()->GetID()).GetPosition();
		vec3 actPos = pos;
		for(unsigned int i = 0; i < ptr[0]->GetNumberOfStrips(); i++)
		{
			vec3 trans(ptr[0]->GetWidthOfItemsAtStrip(i), 0.0, ptr[0]->GetHeightOfItems());
			vec3 trans_rendering = trans / 2.0f; 

			actPos.x = pos.x;
			for(unsigned int j = 0; j < ptr[0]->GetStripAt(i)->GetNumberOfItems(); j++)
			{
				SetGUIVertexForView(ptr[0]->GetStripAt(i)->GetItemAt(j)->GetID(), GUIVertex(actPos, vec3(0,1,1), 1));
				ptr.push_back(m_mapVertex[ptr[0]->GetStripAt(i)->GetItemAt(j)->GetID()]);
				actPos.x = actPos.x + trans.x;
			}
			actPos.z = actPos.z + trans.z;
		}
		ptr.erase(ptr.begin());
	}
	//Calculate Endpos (werden zentriert)
	parentNode = m_pkGraph->GetRoot();
	GUIVertex v = GetGUIVertexForView(parentNode->GetID());
	v.SetPosition( v.GetPosition() + vec3(m_mapVertex[parentNode->GetID()]->GetWidth() * 0.5, 0.0, m_mapVertex[parentNode->GetID()]->GetHeight() * 0.5));
	SetGUIVertexForView(parentNode->GetID(), v);
	ptr.push_back(m_mapVertex[parentNode->GetID()]);
	while(ptr.size() > 0)
	{
		for(unsigned int i = 0; i < ptr[0]->GetNumberOfStrips(); i++)
		{
			for(unsigned int j = 0; j < ptr[0]->GetStripAt(i)->GetNumberOfItems(); j++)
			{
				GUIVertex v = GetGUIVertexForView(ptr[0]->GetStripAt(i)->GetItemAt(j)->GetID());
				v.SetPosition( v.GetPosition() + vec3(m_mapVertex[ptr[0]->GetStripAt(i)->GetItemAt(j)->GetID()]->GetWidth() * 0.5, 0.0, m_mapVertex[ptr[0]->GetStripAt(i)->GetItemAt(j)->GetID()]->GetHeight() * 0.5));
				SetGUIVertexForView(ptr[0]->GetStripAt(i)->GetItemAt(j)->GetID(), v);
				
				ptr.push_back(m_mapVertex[ptr[0]->GetStripAt(i)->GetItemAt(j)->GetID()]);
			}
		}

		ptr.erase(ptr.begin());
	}
}